#include 'UDF\I2D_Nano.au3'
#include 'UDF\EasyASM\EasyASM.au3'

_ASM_Startup()
_GDIPlus_Startup()

Global $vOP_RC = _ASM_AddOP(__OP_RC())

Local $vIMG = _I2D_BufferCreateFromFile(@ScriptDir & '\aaa1.bmp') ; Buffer laden

_I2D_BufferReplaceColor($vIMG, 0xFFFFFF00, 0xFF204080)

_GDIPlus_ImageSaveToFile($vIMG.BMP, @ScriptDir & '\test.png') ; Anbindung an GDI+ ist da. in vIMG.BMP steckt ein ganz normales GDI+ Bitmap

_GDIPlus_Shutdown()
_ASM_Shutdown()

Func _I2D_BufferReplaceColor($vIMG, $iCol1, $iCol2)
	Local $vParam = DllStructCreate('int a[3]')
	$vParam.a(1) = DllStructGetPtr($vIMG)
	$vParam.a(2) = $iCol1
	$vParam.a(3) = $iCol2
	_ASM_Call($vOP_RC, DllStructGetPtr($vParam))
EndFunc

Func __OP_RC() ; Replace Color
	_('use32')

	_('mov eax, [esp+4]') ; Ptr von vParam
	_('mov edx, [eax]')   ; Ptr von vIMG
	; #DEF# =========================================================================================================================
	; I2D bedeutet Image 2D
	; int[0] - GFX -> GDIPlusGraphics des Buffers
	; int[1] - BMP -> GDIPlusBitmap des Buffers
	; int[2] - PTR -> Pointer auf die Bitmapdaten (mit ASM/Structs ansprechbar)
	; int[3] - WIDTH  -> Breite des Buffers
	; int[4] - HEIGHT -> Hhe des Buffers
	; Sinn der Sache ist es eine einfache Verbindung zwischen GDI+ und Structs/ASM herzustellen.
	; ===============================================================================================================================

	_('mov ebx, [edx+12]') ; Breite
	_('mov ecx, [edx+16]') ; Hhe
	_('imul ecx, ebx')     ; Anzahl Pixel in ecx

	_('mov edi, [edx+8]')  ; Ptr fr Bitmapdaten
	_('mov edx, [eax+4]')  ; Suchfarbe
	_('mov esi, [eax+8]')  ; Ersetzungsfarbe
	_('mov eax, esi')      ; Persnliche Sache, ich hab esi lieber nicht mit einer Farbe belegt.

	_('MainLoop:')         ; For $i = AnzahlPx to 0 Step -1
	_('cmp edx, [edi]')    ; Suchen
	_('jne NichtGleich')   ; If
	_('mov [edi], eax')    ; Ersetzen
	_('NichtGleich:')      ; Endif
	_('add edi, 4')        ; Nchster Pixel
	_('dec ecx')           ; Step -1
	_('ja MainLoop')       ; Next falls ecx > 0

	_('ret')
EndFunc